package com.diagbot.facade;

import com.diagbot.dto.CriticalNeoDTO;
import com.diagbot.dto.IndicationDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.process.CriticalProcess;
import com.diagbot.vo.CriticalNeoVO;
import com.diagbot.vo.IndicationPushVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;
import java.util.List;

/**
 * @Description: 危急值facade
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class CriticalFacade {

    @Autowired
    NeoFacade neoFacade;
    @Autowired
    CriticalProcess criticalProcess;

    /**
     * 高风险提示
     * @param
     * @return
     */
    public void criticalFac(IndicationPushVO indicationPushVO, WordCrfDTO wordCrfDTO, IndicationDTO res) {
        // 危急值图谱接口调用
        CriticalNeoVO criticalNeoVOs = fillCriticalNeo(wordCrfDTO);
        List<CriticalNeoDTO> criticalNeoDTOList = neoFacade.getCritialNeo(criticalNeoVOs);

        // TODO 测试数据开始
        CriticalNeoDTO criticalNeoDTO = new CriticalNeoDTO();
        criticalNeoDTO.setName("血小板计数");
        criticalNeoDTO.setStandname("血小板计数");
        criticalNeoDTO.setType("化验");
        NodeNeoDTO nodeNeoDTO = new NodeNeoDTO();
        nodeNeoDTO.setMax(new BigDecimal("100"));
        criticalNeoDTO.setCritical(nodeNeoDTO);
        criticalNeoDTOList.add(criticalNeoDTO);

        CriticalNeoDTO criticalNeoDTO1 = new CriticalNeoDTO();
        criticalNeoDTO1.setName("红细胞压积");
        criticalNeoDTO1.setStandname("红细胞压积");
        criticalNeoDTO1.setType("化验");
        NodeNeoDTO nodeNeoDTO1 = new NodeNeoDTO();
        nodeNeoDTO1.setVal("阳性");
        criticalNeoDTO1.setCritical(nodeNeoDTO1);
        criticalNeoDTOList.add(criticalNeoDTO1);
        // TODO 测试数据结束

        // 规则处理
        criticalProcess.process(criticalNeoDTOList, wordCrfDTO, res);
    }




    public CriticalNeoVO fillCriticalNeo(WordCrfDTO wordCrfDTO) {
        CriticalNeoVO criticalNeoVO = new CriticalNeoVO();

        criticalNeoVO.setAge(wordCrfDTO.getAge());
        criticalNeoVO.setSex(wordCrfDTO.getSex());
        criticalNeoVO.setVitalLabel(wordCrfDTO.getVitalLabel());
        criticalNeoVO.setLis(wordCrfDTO.getLis());


        return criticalNeoVO;
    }
}
