package com.diagbot.model.ai.process;

import com.alibaba.fastjson.JSONObject;
import com.diagbot.model.ai.model.EntityEnum;
import com.diagbot.model.ai.model.Lemma;
import com.diagbot.model.entity.BodyPart;
import com.diagbot.model.entity.Pacs;
import com.diagbot.model.entity.PacsNew;

import java.util.ArrayList;
import java.util.List;

/**
 * @author kwz
 * @date 2020/8/19
 * @time 14:03
 */
public class EntityProcessPacsNew extends EntityProcess {

    public void extractEntity(JSONObject aiOut, PacsNew pacsNew) {
        //辅检描述情况
        List<Pacs> pacses = new ArrayList<>();
        List<Lemma> pacsLemmas = createEntityTree(aiOut, EntityEnum.AUXILIARY_DESCRIPT.toString());
        for (Lemma lemma : pacsLemmas) {
            Pacs pacs = new Pacs();
            pacs.setName(lemma.getText());
            pacs.setStandName(lemma.getText());
            if (lemma.isHaveChildren()) {
                List<BodyPart> bodyPartList = new ArrayList<>();
                for (Lemma relationLemma : lemma.getRelationLemmas()) {
                    if (relationLemma.getProperty().equals(EntityEnum.BODY.toString())) {
                        bodyPartList.add(addBodyPart(relationLemma));
                    }
                }
                pacs.setBodyPartList(bodyPartList);
            }
            pacses.add(pacs);
        }
        pacsNew.setPacsResults(pacses);

        // 辅检诊断信息
        List<Pacs> pacsDisList = new ArrayList<>();
        List<Lemma> disLemmas = createEntityTree(aiOut, EntityEnum.DIEASE.toString());
        for (Lemma lemma : disLemmas) {
            Pacs pacs = new Pacs();
            pacs.setName(lemma.getText());
            pacs.setStandName(lemma.getText());
            pacsDisList.add(pacs);
        }
        pacsNew.setDisease(pacsDisList);
    }

    /**
     * 添加身体部位
     *
     * @param relationLemma
     * @return
     */
    private BodyPart addBodyPart(Lemma relationLemma) {
        BodyPart bodyPart = new BodyPart();
        bodyPart.setName(relationLemma.getText());
        bodyPart.setStandName(relationLemma.getText());
        return bodyPart;
    }
}
