package com.diagbot.rule;

import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoMaxDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.model.entity.Vital;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.ListUtil;
import com.diagbot.util.StringUtil;

import java.util.List;

/**
 * @description: 体征规则
 * @author: kwz
 * @time: 2020/8/3 14:47
 */
public class VitalRule {

    /**
     * 比较体征
     *
     * @param inputLis
     * @param billNeoMaxDTO
     * @return
     */
    public static void compareVitalWithBill(List<Vital> inputLis, BillNeoMaxDTO billNeoMaxDTO, List<BillMsg> billMsgList, String type) {
        List<NodeNeoDTO> neoList = billNeoMaxDTO.getVitals();
        if(ListUtil.isNotEmpty(neoList) && ListUtil.isNotEmpty(inputLis)){
            for (NodeNeoDTO neo : neoList) {
                for (Vital vit : inputLis) {
                    String val = vit.getName();
                    val = vit.getStandName();
                    if (StringUtil.isNotBlank(val) && val.equals(neo.getName()) && "体温".equals(val)) {
//                        String val_name = lis.getDetailName();
                        // 如果有结果数据，就不用比较数值
                        String message = "";
                        boolean flag = false;
//                        if (StringUtil.isNotBlank(lis.getValue())) {
//                            flag = CoreUtil.compareStr(neo, lis.getValue());
//                            if (flag) {
//                                message = CoreUtil.getStrMsg(neo, val, lis.getValue());
//                            }
//                        } else
                            if (vit.getPd() != null) {
                            flag = CoreUtil.compareNum(neo, Double.parseDouble(vit.getPd().getValue()));
                            if (flag) {
                                message = CoreUtil.getNumMsg(neo, val, Double.parseDouble(vit.getPd().getValue()), vit.getPd().getUnit());
                            }
                        }
                        if (flag) {
                            BillMsg commonBillMsg = CoreUtil.getCommonBillMsg(billNeoMaxDTO.getOrderName(),
                                    billNeoMaxDTO.getOrderStandName(), message, type);
                            billMsgList.add(commonBillMsg);
                        }
                    }
                }
            }
        }
    }
}
